<?php
    $lite = isset($_GET["lite"]);

    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;

    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;
    
	require_once("lib/fconnect.php");
	$db = DBConnect::getInstance();
    $a                  = require(__DIR__ .'/../../conf/conf.php');
    $prefix             = $a['db_prefix'];   
    $server = $a['mongo_host'].':'.$a['mongo_port'];
    $mn = new \MongoClient($server);

    $language = "ru";
    $pageType = "chair";
    $currentPageType = DocumentType::findByType($mn, $prefix, $pageType);
			function short_name($str){
				$data= explode(" ", $str);
				return $data[0];
			} 
?><!doctype html>

<html lang="ru">
<head>
  <meta charset="utf-8" />
  <title>Просмотр всех данных</title>
  
  <link rel="stylesheet" href="/css/jquery-ui.css" />
  <link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
  <link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
  <link rel="stylesheet" href="/css/admin.css" />
  <link rel="stylesheet" href="/css/navigation__horizontal.css" />
  <link rel="stylesheet" href="/css/overview.table.css" />
   <link rel="stylesheet" href="/css/monitoring.css" /> 
  <script src="/js/jquery-1.9.1.js"></script>
  <script src="/js/jquery-ui.js"></script>
  <script src="/js/jquery.form.js"></script>
  <script src="/js/bootstrap.min.js"></script>
  <script src="/js/overview.table.js"></script>

  <script src="/js/auth.js"></script>

  <style>

  .main-page__content {
      margin-top: 60px;
      font-size: 2em;
      text-align: center;
  }

  </style>
</head>
<body>	
<?php 
	if(isset($_POST['change'])){
		unset($_POST['change']);
		foreach($_POST as $uuid => $action){
			if($action == 'report_confirm'){
				$dataset = array('$set' => array('report'=>true));
			}
			if($action == 'report_cancel'){
				$dataset = array('$set' => array('report'=>false));
			}
			$docID = array('uuid' =>  $uuid);
			$db->colDocs->update($docID, $dataset);
		}
}
	if(isset($_POST['upload_decline'])){
		$collection = $db->colDoc;
		$filter = array('uuid' => $_POST['upload_decline']);
		$data = array('$set' => array('uploaded' => '0'));	
		$db->colDocs->update($filter, $data, array('multiple' => true));	
}
	if(isset($_POST['upload_confirm'])){

		$collection = $db->colDoc;
		$filter = array('uuid' => $_POST['upload_confirm']);
		$data = array('$set' => array('uploaded' => '1'));	
		$db->colDocs->update($filter, $data, array(
  'multiple' => true)
);
	}	
	if(isset($_POST['upload2_decline'])){
		$collection = $db->colDoc;

		$filter = array('uuid' => $_POST['upload2_decline']);
		$data = array('$set' => array('uploaded2' => '0'));	
		$db->colDocs->update($filter, $data, array('multiple' => true));	
}
	if(isset($_POST['upload2_confirm'])){
		$collection = $db->colDoc;
		$filter = array('uuid' => $_POST['upload2_confirm']);
		$data = array('$set' => array('uploaded2' => '1'));	
		$db->colDocs->update($filter, $data, array(
  'multiple' => true)
);
	}	
	 ?>
<form method="post" action="monitoring_admin.php">
<div class="overview">

<div id="overview-table-top-wrapper">
  <table class="overview__table overview__table--horizontal overview__table--top" id="overview-table-top"></table>
</div>

<div id="overview-table-left-wrapper">
  <table class="overview__table overview__table--horizontal overview__table--left" id="overview-table-left"></table>
</div>

<div id="overview-table-top-left-wrapper">
  <table class="overview__table overview__table--horizontal overview__table--top-left" id="overview-table-top-left"></table>
</div>
<table class="overview__table overview__table--horizontal" id="overview-table">
  <thead>
    <tr>
<?php
    $fields = array_filter($currentPageType->items, function($item) {
          return in_array($item["name"], array("title", "uuid", "visited", "confirmed", "uploaded", "url","uploaded2","url2"));
        });

    $cells = "";

    $title_cell = "";
    $confirmed_cell = "";
    $visited_cell = "";
    
	$uploaded_cell = "";
	$url_cell = "";
	
	$uploaded2_cell = "";
	$url2_cell = "";
	
    foreach ($fields as $ovItem) {
        $labelVar = "label_" . $language;
        $ovItemLabel = $ovItem[$labelVar];
        $ovItemName = $ovItem["name"];
        $cell = '
        <td class="overview-table-cell-' . $ovItemName . '" data-item="' . $ovItemName . '">
        ' . short_name($ovItemLabel) . "</td>";

        if ($ovItemName == "title") {
            $title_cell = $cell;
            continue;
        }
		 if ($ovItemName == "url") {
            $url_cell = $cell;
            continue;
        }
        if ($ovItemName == "url2") {
            $url2_cell = $cell;
            continue;
        }
        
        if ($ovItemName == "confirmed") {
            $confirmed_cell = $cell;
            continue;
        }
        if ($ovItemName == "visited") {
            $visited_cell = $cell;
            continue;
        }
        if ($ovItemName == "uploaded") {
		    $uploaded_cell = $cell;
            continue;
        }
        if ($ovItemName == "uploaded2"){
		    $uploaded2_cell = $cell;
            continue;	
		}
        if ($ovItemName == "uuid") {
			$pdf_cell = '<td>Отчет</td>'; 
            continue;
        }
        $cells .= $cell;
    }

  echo  $cells = ''
           . $title_cell
           . $visited_cell
           . $confirmed_cell
           . $pdf_cell
           . '<td>Наука</td>'
           . '<td>Ссылки</td>'
           . '<td>Управление</td>'
           
           . '<td>Воспит.</td>'
           . '<td>Ссылки</td>'
           . '<td>Управление</td>'
                    
           . $cells;
?>
    </tr>
  </thead>
  <tbody>
<?php
    $ovDocuments = Document::find($mn, $prefix, $currentPageType->type);

    $rowsByParent = array();

    foreach ($ovDocuments as $ovDocument) {
     
        $docConfirmed = $ovDocument->getFieldI18nValue("confirmed");
        $docVisited = $ovDocument->getFieldI18nValue("visited");
		$docId = $ovDocument->getFieldI18nValue("uuid");
        $docParent = $ovDocument->getFieldI18nValue("parent");
		
        $row = "";
        $row .= '<tr>';
        $cells = "";
        $title_cell = "";
        $confirmed_cell = "";
        $visited_cell = "";
		$uploaded_cell = "";
		$url_cell = "";
		$uploaded2_cell = "";
		$url2_cell = "";

        foreach ($fields as $ovItem) {
            $labelVar = "label_" . $language;
            $ovItemLabel = $ovItem[$labelVar];
            $ovItemName = $ovItem["name"];
            $ovItemI18nName = (isset($ovItem["no_i18n"]) && $ovItem["no_i18n"]) ? ($ovItemName) : ($ovItemName . "_" . $language);
            $ovItemValue = isset($ovDocument->fields[$ovItemI18nName]) ? $ovDocument->fields[$ovItemI18nName] : "";

            if (!is_scalar($ovItemValue)) {
                $ovItemValue = "...";
            }
            $ovItemValueOld = null;

            $valueContent = ''
                    . '<div>'
                      . $ovItemValue
                    . '</div>';

            $cell = '<td class="overview-table-cell-' . $ovItemName . '" data-item="' . $ovItemName . '">'
                        .$valueContent
                    . " </td>";
					
			
		    if ($ovItemName == "url") {
          		if($ovItemValue != "" && substr($ovItemValue, 0, 4) == "http"){
						$url_cell = '<td class="overview-table-cell-' . $ovItemName . '" data-item="' . $ovItemName . '">
               			<a href="'.$ovItemValue.'" target="_blank">перейти</a></td>';
				}else{
						$url_date_cell = '<td></td>';
						$url_cell = '<td style="text-decoration:line-through">URL</td>';
				}
				continue;
           }
			if ($ovItemName == "url2") {
          		if($ovItemValue != "" && substr($ovItemValue, 0, 4) == "http"){
						$url2_cell = '<td class="overview-table-cell-' . $ovItemName . '" data-item="' . $ovItemName . '">
               			<a href="'.$ovItemValue.'" target="_blank">перейти</a></td>';
				}else{
						$url2_date_cell = '<td></td>';
						$url2_cell = '<td style="text-decoration:line-through">URL</td>';
				}
				continue;
           }	 
			 
           if ($ovItemName == "title") {
                $title_cell = $cell;
                continue;
            }		
            if($ovItemName == "uploaded"){
                $uploaded_cell = '<td class="overview-table-cell-' . $ovItemName
                    . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no')
                    . '" data-item="' . $ovItemName . '">'
                    . ($ovItemValue
                        ? '<i class="glyphicon glyphicon-thumbs-up icon-thumbs-up"></i> '
                        : '<i class="glyphicon glyphicon-thumbs-down icon-thumbs-down"></i>'
                        ) . '</td>';				
				
				continue;
			}
			if($ovItemName == "uploaded2"){
                $uploaded2_cell = '<td class="overview-table-cell-' . $ovItemName
                    . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no')
                    . '" data-item="' . $ovItemName . '">'
                    . ($ovItemValue
                        ? '<i class="glyphicon glyphicon-thumbs-up icon-thumbs-up"></i> '
                        : '<i class="glyphicon glyphicon-thumbs-down icon-thumbs-down"></i>'
                        ) . '</td>';				
				
				continue;
			}
            if ($ovItemName == "confirmed") {
                $confirmed_cell = '<td class="overview-table-cell-' . $ovItemName
                    . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no')
                    . '" data-item="' . $ovItemName . '">'
                    . ($ovItemValue
                        ? '<i class="glyphicon glyphicon-ok-sign icon-ok-sign"></i> '
                        : '<i class="glyphicon glyphicon-remove-sign icon-remove-sign"></i>'
                        ) . '</td>';
                continue;
            }
            if ($ovItemName == "visited") {
                $visited_cell = '<td class="overview-table-cell-' . $ovItemName
                    . ' overview-table-cell-' . $ovItemName . '-' . ($ovItemValue ? 'yes' : 'no')
                    . '" data-item="' . $ovItemName . '">'
                    . ($ovItemValue
                        ? '<i class="glyphicon glyphicon-eye-open icon-eye-open"></i> '
                        : '<i class="glyphicon glyphicon-eye-close icon-eye-close"></i>'
                        ) . '</td>';
                continue;
            }
            if ($ovItemName == "uuid") {
				$chair = $db->colDocs->findOne(array('uuid'=>$ovItemValue)); 
				if(@$chair['report']){
					$pdf_cell = '<td class="report_given"><input type="checkbox" name="'.$ovItemValue.'" value="report_cancel"> Отчет сдан</td>';
				}else{
					if(!file_exists('pdf/'.md5($ovItemValue).'.pdf')){
						$pdf_cell = '<td class="no_pdf"> PDF не создан</td>';
					}else{
						$pdf_cell = '<td class="pdf"><input type="checkbox" name="'.$ovItemValue.'" value="report_confirm"> PDF создан</td>';
					}
				}
            	$uploaded_button = '<td>
            	<button name="upload_confirm" value="'. $ovItemValue.'">ДА</button>
            	<button name="upload_decline" value="'. $ovItemValue.'">НЕТ</button></td>';
            	$uploaded2_button = '<td>
            	<button name="upload2_confirm" value="'. $ovItemValue.'">ДА</button>
            	<button name="upload2_decline" value="'. $ovItemValue.'">НЕТ</button></td>';
                continue;
            }

            $cells .= $cell;
        }

        $cells = ''
               . $title_cell
               . $visited_cell
               . $confirmed_cell
               . $pdf_cell
               . $uploaded_cell
               . $url_cell     
               . $uploaded_button
               
               . $uploaded2_cell
               . $url2_cell     
               . $uploaded2_button
                
               . $cells;

        $row .= $cells;

        $row .= '</tr>';

        $rowsByParent[$docParent][] = $row;
    }

     $rowsByParentSorted = array_reduce(array_keys($rowsByParent), function($full, $parentUuid) use ($rowsByParent, $mn, $prefix, $language) {
            $parentDoc = Document::findByUuid($mn, $prefix, $parentUuid);
            if ($parentDoc) {
                $parentTitle = $parentDoc->getFieldI18nValue("title", $language);

                $parentRows = $rowsByParent[$parentUuid];
                sort($parentRows);

                $full[$parentTitle][] = '<tr><td colspan="10"><b>' . $parentTitle . '</b></td></tr>'
                            . implode("\n", $parentRows);
            }

            return $full;
        }, array());

    echo implode("\n", array_map(function($_it) {
            return implode("", $_it);
        }, $rowsByParentSorted));

?>

</tbody>
</table>
<input type="submit" name="change" value="Изменить">
</div>
</form>


</body>
</html>
